//=============================================================================
//
//  CLASS PointLight - IMPLEMENTATION
//
//=============================================================================
#define RAYTRACER_POINTLIGHT_CPP

//== INCLUDES =================================================================
#include "PointLight.h"

//== IMPLEMENTATION ==========================================================

/*!

*/
void PointLight::shadowFeeler(   
    Ray             &clRay,         
    double        &rRayDomain,    
    ColorType       &colIntensity )  const
{
    clRay.setDir( m_v3Position - clRay.getOrigin() );
    rRayDomain = 1;

    //attenuation
    colIntensity = m_colIntensity * ( 1 / clRay.getDir().length() );
};


void PointLight::renderGL(
    GLint   number )  const
{
    /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
    VectorType3 position = getPosition();
    GLfloat     light_position[] = { position[0], position[1], position[2] };
    ColorType   color = getIntensity();
    GLfloat     light_ambient[] = { color.red(), color.green(), color.blue(), 0.0 };
    GLfloat     light_diffuse[] = { color.red(), color.green(), color.blue(), 0.0 };
    /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

    glLightfv( number, GL_AMBIENT, light_ambient );
    glLightfv( number, GL_DIFFUSE, light_diffuse );
    glLightfv( number, GL_POSITION, light_position );
}
