#define RAYTRACER_TOOLS_CPP

//== INCLUDES =================================================================
#include "Tools.h"
   
//== IMPLEMENTATION ========================================================== 


void constructONB(const VectorType3& v, VectorType3& x, VectorType3& y, VectorType3& z ) 
{
	z = v;
	z.normalize();
	
	//construct an orthogonal vector
	if ( fabs(z[0]) < fabs(z[1]) && fabs(z[0]) < fabs(z[2]) )
	{
		x[0] = 0; x[1] = z[2]; x[2] =-z[1];
	}
	else if (fabs(z[1]) < fabs(z[2]))
	{
		x[0] = z[2]; 
		x[1] = 0;
		x[2] = -z[0];
	}
	else
	{
		x[0] = z[1];
		x[1] =-z[0];
		x[2] = 0;
	}
	x.normalize();
	y = x%z;
};

//-----------------------------------------------------------------------------

void 
polar2Cartesian( double theta, double phi, double res[3] )
{
	double ct = (double) cos(theta);
	double cp = (double) cos(phi);
	double st = (double) sin(theta);
	double sp = (double) sin(phi);
	res[0] = st*cp;
	res[1] = st*sp;
	res[2] = ct;
};

//-----------------------------------------------------------------------------

double deg2rad( double deg )
{
	return deg / 180 * constants::pi;
};